'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;desc = parent = getter = undefined;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _Compiler2 = require('../Compiler');var _Compiler3 = _interopRequireDefault(_Compiler2);var _CompileResult = require(
'../CompileResult');var _CompileResult2 = _interopRequireDefault(_CompileResult);var _EntryPoint = require(
'../../EntryPoint');var _EntryPoint2 = _interopRequireDefault(_EntryPoint);var _WebpackAssetServer = require(
'./WebpackAssetServer');var _WebpackAssetServer2 = _interopRequireDefault(_WebpackAssetServer);

var path = require('path');
var fs = require('fs');
var rimraf = require('rimraf');
var COMMONS_ENTRY_NAME = '__commons';

/**
 * @SERVER
 */var 
WebpackCompiler = (function (_Compiler) {_inherits(WebpackCompiler, _Compiler);























































  /**
   * @param {Logger} logger
   * @param {Object} frameworkConfig
   * @param {any} webpack
   * @param {any} react
   * @param {Function} webpackDevMiddleware
   * @param {Function} webpackHotMiddleware
   */
  function WebpackCompiler(logger, frameworkConfig, webpack, react, 
  webpackDevMiddleware, webpackHotMiddleware) {_classCallCheck(this, WebpackCompiler);
    _get(Object.getPrototypeOf(WebpackCompiler.prototype), 'constructor', this).call(this);
    this._logger = logger;
    this._react = react;
    this._webpack = webpack;
    this._webpackDevMiddleware = webpackDevMiddleware;
    this._webpackHotMiddleware = webpackHotMiddleware;
    this._frameworkConfig = frameworkConfig;
    this._clientReplace = frameworkConfig.clientReplace;
    this._clientResolve = frameworkConfig.clientResolve;
    this._absoluteClientBuildDir = frameworkConfig.absoluteClientBuildDir;
    this._assetHostPath = frameworkConfig.assetHostPath;
    this._assetServer = new _WebpackAssetServer2['default'](this._assetHostPath, this._absoluteClientBuildDir, logger);

    if (this._frameworkConfig.hotReload && (!webpackDevMiddleware || !webpackHotMiddleware)) {
      throw new Error('Hot reload flag is true, yet webpack dev/hot middleware is not passed to WebpackCompiler.');}


    this._cleanTempDir();}


  /**
   * @param {any} webpack
   * @param {Object} frameworkConfig
   * @returns {Object}
   */_createClass(WebpackCompiler, [{ key: 'run', 




































































































    /**
     * 1) Create configuration with one common file for webpack.
     * 2) Compile webpack from source to temporary location, with CSS loader
     *    and file loader.
     * 3) Read all files to AssetServer - AssetServer could just read the
     *    files, but cache everything.
     *
     *    TODO: Make babel optional
     *    TODO: Allow user setting of loaders.
     *
     * @param {Array<EntryPoint>} entryPoints
     * @param {Function} updateCompileResultCallback
     * @return {Array<Function>}
     */value: 
    function run(entryPoints, updateCompileResultCallback) {var _this = this;
      var i, j, entryPoint, entryPointList = [];
      var configuration = { 
        entry: {}, 
        output: { 
          path: this._absoluteClientBuildDir, 
          filename: "[name]-[chunkhash].js", 
          publicPath: this._frameworkConfig.assetProtocol + '://' + this._assetHostPath }, 

        module: { 
          loaders: [
          WebpackCompiler.getBabelLoaderConfig(this._frameworkConfig, []), 
          WebpackCompiler.getFileLoaderConfig(this._frameworkConfig), 
          { test: /\.css$/, loader: "style-loader?returnComplete=true!css-loader" }] }, 



        // Right now we don't need these, since we're compiling via webpack.
        // But we still need to figure out how to send transformer with state
        // to babel-loader. Maybe use "extra" like react-transform? We need
        // to send functions, so that could also not work, worst case scenario
        // is to rely on regex strings instead.
        // TODO: Fix client resolve feature, make it work.
        babel: { 
          plugins: [
          "flow-comments", 
          { 
            transformer: this._createPlugin(), 
            position: 'after' }] }, 




        resolve: { alias: {} }, 
        plugins: [new this._webpack.optimize.OccurenceOrderPlugin()] };


      for (i in this._clientReplace) {
        if (!this._clientReplace.hasOwnProperty(i)) continue;
        configuration.resolve.alias[i] = this._clientReplace[i];}


      if (this._frameworkConfig.hotReload) {
        configuration.plugins.push(new this._webpack.HotModuleReplacementPlugin());}


      configuration.plugins.push(new this._webpack.NoErrorsPlugin());
      configuration.plugins.push(new this._webpack.optimize.CommonsChunkPlugin(
      COMMONS_ENTRY_NAME, 'common-[hash].js', entryPointList));


      if (this._frameworkConfig.minifyJs) {
        configuration.plugins.push(new this._webpack.optimize.UglifyJsPlugin({}));}


      var clientRuntime, entryPointFileName, pageToRequire;
      for (i = 0; i < entryPoints.length; i++) {
        entryPoint = entryPoints[i];
        pageToRequire = path.join(entryPoint.rootAbsolutePath, entryPoint.name + '.js');
        entryPointFileName = path.join(this._absoluteClientBuildDir, '__entry-' + entryPoint.name + '.js');
        clientRuntime = this._generateClientRuntime(pageToRequire);
        fs.writeFileSync(entryPointFileName, clientRuntime);
        configuration.entry[entryPoint.name] = entryPointFileName;
        entryPointList.push(entryPoint.name);}


      var compiler = this._webpack(configuration);
      var self = this;

      compiler.plugin('done', function (stats) {
        if (stats.compilation.errors.length > 0) {
          // Error occured. Print error messages.
          _this._printErrorMessages(stats);
          return;}


        var i, chunkMap = {};
        for (i = 0; i < stats.compilation.chunks.length; i++) {
          chunkMap[stats.compilation.chunks[i].name] = stats.compilation.chunks[i];}

        var commonsChunk = chunkMap[COMMONS_ENTRY_NAME];

        var compileResult = new _CompileResult2['default'](), entryPointChunk, entryPointName, pageDep;
        for (i = 0; i < entryPointList.length; i++) {
          entryPointName = entryPointList[i];
          if (!chunkMap.hasOwnProperty(entryPointName)) {
            throw new Error('Unable to determine dependency, entry point ' + entryPointName + ' does not have webpack chunk!');}

          entryPointChunk = chunkMap[entryPointName];

          pageDep = { 
            cssDependencies: [], 
            jsDependencies: [] };


          for (j = 0; j < commonsChunk.files.length; j++) {
            pageDep.jsDependencies.push(self._assetServer.toUrlWithoutProtocol(
            commonsChunk.files[j]));}


          for (j = 0; j < entryPointChunk.files.length; j++) {
            pageDep.jsDependencies.push(self._assetServer.toUrlWithoutProtocol(
            entryPointChunk.files[j]));}



          compileResult.pages[entryPointName] = pageDep;}


        updateCompileResultCallback(compileResult);});


      compiler.plugin('failed', function (err) {
        // Error ocurred. Print error messages.
        _this._printErrorMessages(err);});


      var middlewares = [];

      if (this._frameworkConfig.hotReload) {
        // Let webpack-dev-middleware handles watching, storing output and serving
        // asset requests. Meanwhile, webpack hot middleware should be accepting
        // connection from the client.
        middlewares.push(this._webpackDevMiddleware(compiler, { 
          noInfo: true, 
          publicPath: configuration.output.publicPath }));

        middlewares.push(this._webpackHotMiddleware(compiler));} else 
      {
        // Middleware for regular webpack asset server.
        middlewares.push(function (request, response, next) {
          var handledByAssetServer = _this._assetServer.handle(request, response);
          if (!handledByAssetServer) {
            next();}});



        // We only need to run if we are not hot reloading, since
        // webpack-dev-middleware already runs watch() for us.
        compiler.run(function () {
          // No-op. We'll use the above 'done' and 'failed' hook to notify
          // application for successes and failures.
        });}


      return middlewares;}


    /**
     * TODO: Find out a library for escaping URLs to be put in HTML.
     *
     * @param {string} componentName
     * @param {Object} routeArgs
     * @param {Object} pageDependencies
     * @param {RenderResult} renderResult
     * @param {Config} clientConfig
     * @param {boolean} isSecure
     * @returns {string}
     */ }, { key: 'assembleHtml', value: 
    function assembleHtml(componentName, routeArgs, pageDependencies, 
    renderResult, clientConfig, isSecure) {
      var result = '<html>';
      result += '<head>';
      if (renderResult.head) result += renderResult.head;

      result += '<script type="text/javascript">';
      result += 'var config = ' + JSON.stringify(clientConfig) + ';';
      result += 'var routeArgs = ' + JSON.stringify(routeArgs) + ';';
      result += '</script>';

      var i, url, dep;
      for (i = 0; i < pageDependencies.cssDependencies.length; i++) {
        url = isSecure ? 'https://' : 'http://';
        url += pageDependencies.cssDependencies[i];
        result += '<link rel="stylesheet" type="text/css" src="' + url + '">';}


      result += '</head>';
      result += '<body><div id="__body">';
      if (renderResult.body) result += this._react.renderToString(renderResult.body);
      result += '</div>';

      for (i = 0; i < pageDependencies.jsDependencies.length; i++) {
        url = this._frameworkConfig.assetProtocol + "://";
        url += pageDependencies.jsDependencies[i];
        result += '<script type="text/javascript" src="' + url + '"></script>';}


      result += '</body>';
      result += '</html>';
      return result;} }, { key: '_cleanTempDir', value: 


    function _cleanTempDir() {
      // Remove everything in the directory.
      rimraf.sync(this._absoluteClientBuildDir);

      // Ensure directory exists.
      try {
        fs.mkdirSync(this._absoluteClientBuildDir);} 
      catch (e) {
        if (e.code != 'EEXIST') throw e;}}



    /**
     * @param {any} stats
     */ }, { key: '_printErrorMessages', value: 
    function _printErrorMessages(stats) {
      var error = new Error('Webpack compilation error!');
      this._logger.error('Webpack compilation error -> ', error, [stats.compilation.errors]);
      throw error;}


    /**
     * TODO: Page caching for history API!
     * TODO: Send http request headers, request method, etc - if a config knob is turned on!
     *
     * @param {string} pageToRequire
     * @returns {string}
     */ }, { key: '_generateClientRuntime', value: 
    function _generateClientRuntime(pageToRequire) {
      var pagePath = pageToRequire.replace(/'/g, '\\\'');
      var routerPath = path.join(this._frameworkConfig.absoluteProjectDir, 'router.js');
      routerPath = routerPath.replace(/'/g, '\\\'');
      var result = '';
      if (this._frameworkConfig.hotReload) {
        result += 'window.HotReload = require(\'webpack-hot-middleware/client\');';}

      result += 'var Page = require(\'' + pagePath + '\');' + 
      'var React = require("react");' + 
      'var ClientHttpRequest = require("soya/lib/http/ClientHttpRequest");' + 
      'window.router = require(\'' + routerPath + '\')(window.config);' + 
      'window.page = new Page(window.config, window.router);' + 
      'page.render(new ClientHttpRequest(), window.routeArgs, function(renderResult) {' + 
      'window.renderResult = renderResult;' + 
      'React.render(renderResult.body, document.getElementById("__body"));' + 
      '});';
      return result;} }, { key: '_createPlugin', value: 


    function _createPlugin() {
      var self = this;
      return function (_ref) {var Plugin = _ref.Plugin;var t = _ref.types;
        return new Plugin("soya-webpack-compiler", { 
          visitor: { 
            CallExpression: function CallExpression(node, parent) {
              if (t.isIdentifier(node.callee, { name: "require" })) {
                console.log('HAHAHAHAHAHAHAHAHAHAAAAAAAAAAAAAAAAAAAA');
                var requireValue = node.arguments[0].value;
                if (self._clientResolve) {
                  var i, resolved;
                  for (i = 0; i < self._clientResolve.length; i++) {
                    // TODO: Pass also the absolute path of currently parsed file.
                    resolved = self._clientResolve[i](requireValue);
                    if (resolved != null) {
                      node.arguments[0].value = resolved;
                      return;}}}}} } });};} }], [{ key: 'createServerBuildConfig', value: function createServerBuildConfig(webpack, frameworkConfig) {var nodeModules = {};var absProjectDir = frameworkConfig.absoluteProjectDir;var absEntryPointFile = path.join(frameworkConfig.absoluteProjectDir, 'server.js');var absBuildTargetDir = frameworkConfig.absoluteServerBuildDir;fs.readdirSync(path.join(absProjectDir, 'node_modules')).filter(function (x) {return ['.bin'].indexOf(x) === -1;}).forEach(function (mod) {nodeModules[mod] = 'commonjs ' + mod;});var definePlugin = new webpack.DefinePlugin({ __PROJECT_DIRNAME__: JSON.stringify(absProjectDir) });return { entry: absEntryPointFile, target: 'node', output: { path: absBuildTargetDir, publicPath: frameworkConfig.assetProtocol + '://' + frameworkConfig.assetHostPath, filename: 'index.js' }, node: { __dirname: true, __filename: true }, devtool: 'sourcemap', module: { loaders: [WebpackCompiler.getBabelLoaderConfig(frameworkConfig, []), WebpackCompiler.getFileLoaderConfig(frameworkConfig), { test: /\.css$/, loader: "css-loader" }] }, plugins: [definePlugin, new webpack.BannerPlugin('require("source-map-support").install();', { raw: true, entryOnly: false }), new webpack.optimize.OccurenceOrderPlugin(), new webpack.NoErrorsPlugin()], externals: nodeModules };} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        * @param {Object} frameworkConfig
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        * @param {Array<Object>} extraPlugins
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        * @return {Object}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        */ }, { key: 'getBabelLoaderConfig', value: function getBabelLoaderConfig(frameworkConfig, extraPlugins) {extraPlugins = Array.isArray(extraPlugins) ? extraPlugins : [];var result = { test: /\.jsx?$/, exclude: /(node_modules|bower_components)/, loader: 'babel', query: { optional: ['runtime'], plugins: ["flow-comments"], extra: {}, blacklist: ["flow"], retainLines: true, comments: false } };result.query.plugins = result.query.plugins.concat(extraPlugins);if (frameworkConfig.hotReload) {result.query.plugins.push('react-transform');result.query.extra['react-transform'] = { transforms: [{ 'transform': 'react-transform-hmr', 'imports': ['react'], 'locals': ['module'] }] };}return result;} }, { key: 'getFileLoaderConfig', value: function getFileLoaderConfig(config) {var test;if (config.staticAssetRegex) {test = config.staticAssetRegex;} else {test = /(\.jpg|\.png|\.jpeg|\.gif|\.ico|\.svg|\.eot|\.woff|\.woff2|\.ttf)$/;}return { test: test, loader: "file-loader?name=[path][name]-[hash].[ext]" };} }]);return WebpackCompiler;})(_Compiler3['default']);exports['default'] = WebpackCompiler;module.exports = exports['default']; /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    * @type {{[key: string]: any}}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        * @type {string}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @type {string}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @type {{[key: string]: string}}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    * @type {Array<Function>}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        * @type {WebpackAssetServer}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @type {any}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @type {any}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    * @type {Logger}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        * @type {?Function}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @type {?Function}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */
//# sourceMappingURL=WebpackCompiler.js.map